'###################################################
' AT90S2313
'###################################################
$regfile = "2313def.dat"
$crystal = 4000000                                ' Quarzfrequenz
$baud = 9600                                      'Baudrate fr RS232

Const Tmr_c_prescale = 64
Const Tmr_c_preload = 194

$baud = 9600
$hwstack = 24
$swstack = 24
$framesize = 24


'=========================================================================================
' Timer0 Prescale for 1mS Interrupt
'=========================================================================================
Config Timer0 = Timer , Prescale = Tmr_c_prescale 'Timer 1mS
On Timer0 Interrupt_ticker Nosave                 ' Timer for Timer Queue

Const Rx_bufsize = 24

$include "myrncom23.bas"

'-------------------------------------------------
'           work data
'-------------------------------------------------
Dim Destcls As Byte                               'destination Class
Dim Destidn As Byte                               'destination Ident
Dim Dest As Word At Destcls Overlay

Dim Srcecls As Byte                               'source Class
Dim Srceidn As Byte                               'source Ident
Dim Srce As Word At Srcecls Overlay

Dim Address As Long At Destcls Overlay


Dim Tempb As Byte                                 'message data


Dim Msg As Byte                                   'Message-Base
Dim Leng As Byte                                  'Message-Length
'-------------------------------------------------
'   enable
'-------------------------------------------------
   Enable Timer0
   Enable Interrupts
'-------------------------------------------------
'           main loop
'-------------------------------------------------
   Do
    Msg = Com_msg()
    If Msg <> 0 Then
      Leng = Com_rdbyte()
      Address = Com_rdlong()                      ' read addresses
      Tempb = Com_rdbyte()                        ' read data
      Gosub Echo_message
      Call Com_msgdone(msg)
   End If
   Loop
End
'==============================================================================
' Timer 0  interrupt
'==============================================================================
Interrupt_ticker:
$asm
      PUSH r24
    * In R24 , Sreg
      PUSH r24
      LDI r24, Tmr_c_preload
    * Out Tcnt0 , R24
      POP r24
    * Out Sreg , R24
      POP r24
   $end Asm
Return

Echo_message:
'----------------------------------------------------------------------------
'send Message to host
      Call Com_txstart()
      Call Com_txword(srce)
      Call Com_txword(dest)
' write data-------------
      Call Com_txbyte(tempb)
' finish message---------
      Call Com_txclose()
'----------------------------------------------------------------------------
   Return
